/***********************************************************************/
/*                                                                     */
/* PIDL.hpp    : Header file for ITEMIDLIST wrapper class              */
/*                                                                     */
/*               Copyright (c) Yak! 2005 All rights reserved.          */
/*                                                                     */
/*   $URL: svn://localhost/afxspdir/trunk/PIDL.hpp $                   */
/*  $Date: 2005-11-14 20:30:56 +0900 (Mon, 14 Nov 2005) $              */
/*   $Rev: 54 $                                                        */
/*                                                                     */
/***********************************************************************/

#ifndef PIDL_HPP
#define PIDL_HPP

#include <iosfwd> // for operator <<

#include <shlobj.h> // LPITEMIDLIST


namespace yak {
	namespace utils {
		namespace windows {

			class PIDL // ITEMIDLIST wrapper
			{
			public:
				PIDL(void):pidl(NULL) {}
				PIDL(const PIDL& r);
				PIDL& operator=(const PIDL& r);
				~PIDL(void);
				operator LPITEMIDLIST (void) const {
					return pidl;
				}
				// This conversion operator is quite useful with existing functions
				// However, it is quite confusable in sematics
				operator LPITEMIDLIST* (void);
				// This conversion operator is used in case of `if (pidl) { ... }'
				operator bool(void) { return pidl != NULL; }
				PIDL& assign(LPITEMIDLIST pidl_);
				UINT getSize(void) const;
				PIDL& operator += (const PIDL& r);
				PIDL getParent(void) const;
				PIDL& swap(PIDL& r);
				friend PIDL operator + (const PIDL& r1, const PIDL& r2);
				friend std::ostream& operator << (std::ostream &os, const PIDL& r);
			private:
				static LPITEMIDLIST getNextItemID(LPCITEMIDLIST pidl_);
				void reset(void);
				LPITEMIDLIST pidl;
			};

		}
	}
}

#endif
