/***********************************************************************/
/*                                                                     */
/* odstream.hpp: Header file for stream class using OutputDebugString  */
/*                                                                     */
/*               Copyright (c) Yak! 2005 All rights reserved.          */
/*                                                                     */
/*   $URL: svn://localhost/afxspdir/trunk/odstream.hpp $               */
/*  $Date: 2005-11-13 05:56:25 +0900 (Sun, 13 Nov 2005) $              */
/*   $Rev: 46 $                                                        */
/*                                                                     */
/***********************************************************************/

#ifndef ODSTREAM_HPP
#define ODSTREAM_HPP

#include <iosfwd>

namespace yak {

	namespace debug_yes {
		extern std::ostream ods;
	} // namespace debug_yes

	namespace debug_no {

		class PseudoNullStream;
		extern PseudoNullStream ods;

		extern std::ostream ns;

		class PseudoNullStream
		{
		public:
			template<typename T>
			const PseudoNullStream& operator << (T) const { return ods; }
			const PseudoNullStream& operator << (std::ostream& (*)(std::ostream&)) const { return ods; }
			const PseudoNullStream& operator << (std::ios_base& (*)(std::ios_base&)) const { return ods; }
			const PseudoNullStream& operator << (std::basic_ios<char>& (*)(std::basic_ios<char>&)) const { return ods; }
			operator std::ostream& () { return ns; }
		};

	} // namespace debug_no

#ifndef YAK_DEBUG_NO_DECLARE_NAMESPACE
#ifdef DEBUG
	namespace debug = debug_yes;
#else
	namespace debug = debug_no;
#endif
#endif

} // namespace yak

#endif
