/***********************************************************************/
/*                                                                     */
/* table.cpp   : Source file for convert table for filesystem safe     */
/*                                                                     */
/*               Copyright (c) Yak! 2005 All rights reserved.          */
/*                                                                     */
/*   $URL: svn://localhost/afxspdir/trunk/table.cpp $                  */
/*  $Date: 2005-11-14 22:42:12 +0900 (Mon, 14 Nov 2005) $              */
/*   $Rev: 55 $                                                        */
/*                                                                     */
/***********************************************************************/

// 0 means MBCS lead byte

// VFAT
// \ : * ? < > | / ;

// NTFS
// \ " * ? < > |

// union
// \ : " * ? < > | / ;
// convert to
//   ! ' @ $ ( ) - % ,

char cConvert[256] = {

/* '\x00', '\x01', '\x02', '\x03', '\x04', '\x05', '\x06', '\x07', */
   '\x00', '\x01', '\x02', '\x03', '\x04', '\x05', '\x06', '\x07',   
/* '\x08', '\x09', '\x0A', '\x0B', '\x0C', '\x0D', '\x0E', '\x0F', */
   '\x08', '\x09', '\x0A', '\x0B', '\x0C', '\x0D', '\x0E', '\x0F',   
/* '\x10', '\x11', '\x12', '\x13', '\x14', '\x15', '\x16', '\x17', */
   '\x10', '\x11', '\x12', '\x13', '\x14', '\x15', '\x16', '\x17',   
/* '\x18', '\x19', '\x1A', '\x1B', '\x1C', '\x1D', '\x1E', '\x1F', */
   '\x18', '\x19', '\x1A', '\x1B', '\x1C', '\x1D', '\x1E', '\x1F',   
/* ' ',    '!',    '"',    '#',    '$',    '%',    '&',    '\x27', */
   ' ',    '!',    '\x27', '#',    '$',    '%',    '&',    '\x27',   
/* '(',    ')',    '*',    '+',    ',',    '-',    '.',    '/',    */
   '(',    ')',    '@',    '+',    ',',    '-',    '.',    '%',      
/* '0',    '1',    '2',    '3',    '4',    '5',    '6',    '7',    */
   '0',    '1',    '2',    '3',    '4',    '5',    '6',    '7',      
/* '8',    '9',    ':',    ';',    '<',    '=',    '>',    '?',    */
   '8',    '9',    '!',    ',',    '(',    '=',    ')',    '$',      
/* '@',    'A',    'B',    'C',    'D',    'E',    'F',    'G',    */
   '@',    'A',    'B',    'C',    'D',    'E',    'F',    'G',      
/* 'H',    'I',    'J',    'K',    'L',    'M',    'N',    'O',    */
   'H',    'I',    'J',    'K',    'L',    'M',    'N',    'O',      
/* 'P',    'Q',    'R',    'S',    'T',    'U',    'V',    'W',    */
   'P',    'Q',    'R',    'S',    'T',    'U',    'V',    'W',      
/* 'X',    'Y',    'Z',    '[',    '\\',   ']',    '^',    '_',    */
   'X',    'Y',    'Z',    '[',    '\\',   ']',    '^',    '_',      
/* '`',    'a',    'b',    'c',    'd',    'e',    'f',    'g',    */
   '`',    'a',    'b',    'c',    'd',    'e',    'f',    'g',      
/* 'h',    'i',    'j',    'k',    'l',    'm',    'n',    'o',    */
   'h',    'i',    'j',    'k',    'l',    'm',    'n',    'o',      
/* 'p',    'q',    'r',    's',    't',    'u',    'v',    'w',    */
   'p',    'q',    'r',    's',    't',    'u',    'v',    'w',      
/* 'x',    'y',    'z',    '{',    '|',    '}',    '~',    '\x7F', */
   'x',    'y',    'z',    '{',    '-',    '}',    '~',    '\x7F',   
/* '\x80', 0,      0,      0,      0,      0,      0,      0,      */
   '\x80', 0,      0,      0,      0,      0,      0,      0,        
/* 0,      0,      0,      0,      0,      0,      0,      0,      */
   0,      0,      0,      0,      0,      0,      0,      0,        
/* 0,      0,      0,      0,      0,      0,      0,      0,      */
   0,      0,      0,      0,      0,      0,      0,      0,        
/* 0,      0,      0,      0,      0,      0,      0,      0,      */
   0,      0,      0,      0,      0,      0,      0,      0,        
/* '\xA0', '\xA1', '\xA2', '\xA3', '\xA4', '\xA5', '\xA6', '\xA7', */
   '\xA0', '\xA1', '\xA2', '\xA3', '\xA4', '\xA5', '\xA6', '\xA7',   
/* '\xA8', '\xA9', '\xAA', '\xAB', '\xAC', '\xAD', '\xAE', '\xAF', */
   '\xA8', '\xA9', '\xAA', '\xAB', '\xAC', '\xAD', '\xAE', '\xAF',   
/* '\xB0', '\xB1', '\xB2', '\xB3', '\xB4', '\xB5', '\xB6', '\xB7', */
   '\xB0', '\xB1', '\xB2', '\xB3', '\xB4', '\xB5', '\xB6', '\xB7',   
/* '\xB8', '\xB9', '\xBA', '\xBB', '\xBC', '\xBD', '\xBE', '\xBF', */
   '\xB8', '\xB9', '\xBA', '\xBB', '\xBC', '\xBD', '\xBE', '\xBF',   
/* '\xC0', '\xC1', '\xC2', '\xC3', '\xC4', '\xC5', '\xC6', '\xC7', */
   '\xC0', '\xC1', '\xC2', '\xC3', '\xC4', '\xC5', '\xC6', '\xC7',   
/* '\xC8', '\xC9', '\xCA', '\xCB', '\xCC', '\xCD', '\xCE', '\xCF', */
   '\xC8', '\xC9', '\xCA', '\xCB', '\xCC', '\xCD', '\xCE', '\xCF',   
/* '\xD0', '\xD1', '\xD2', '\xD3', '\xD4', '\xD5', '\xD6', '\xD7', */
   '\xD0', '\xD1', '\xD2', '\xD3', '\xD4', '\xD5', '\xD6', '\xD7',   
/* '\xD8', '\xD9', '\xDA', '\xDB', '\xDC', '\xDD', '\xDE', '\xDF', */
   '\xD8', '\xD9', '\xDA', '\xDB', '\xDC', '\xDD', '\xDE', '\xDF',   
/* 0,      0,      0,      0,      0,      0,      0,      0,      */
   0,      0,      0,      0,      0,      0,      0,      0,        
/* 0,      0,      0,      0,      0,      0,      0,      0,      */
   0,      0,      0,      0,      0,      0,      0,      0,        
/* 0,      0,      0,      0,      0,      0,      0,      0,      */
   0,      0,      0,      0,      0,      0,      0,      0,        
/* 0,      0,      0,      0,      0,      '\xFD', '\xFE', '\xFF', */
   0,      0,      0,      0,      0,      '\xFD', '\xFE', '\xFF',   

};
